<template>
    <div>
        <custom-card>
            <auto-datatable
                ref="dt"
                model="CompanyBank"
                :filters="[
                    {
                        label: $t('name'),
                        name: 'f-name',
                        type: 'text'
                    },
                    [
                        {
                            label: $t('bank_account_holder_name'),
                            name: 'f_like_bank_account_holder_name',
                            type: 'text'
                        },
                        {
                            label: $t('bank_account_number'),
                            name: 'f_like_bank_account_number',
                            type: 'text'
                        }
                    ]

                ]"
                :headers="[
                    {label: '#', name: 'id'},
                    {label: $t('actions'), name: 'actions'},
                    {label: $t('country'), name: 'country_id', column: 'country_name'},
                    {label: $t('bank'), name: 'bank_id', column: 'bank_name'},
                    {label: $t('bank_account_holder_name'), name: 'account_name'},
                    {label: $t('bank_account_number'), name: 'account_number'},
                    {label: $t('created_at'), name: 'created_at'},
                ]"
            >
                <template #action>
                    <create-button
                        :text="$t('create')"
                        @click="model = {}"
                    />
                </template>
                <template #default="{records}">
                    <tr
                        v-for="(record, i) in records"
                        :key="i"
                    >
                        <td>{{ i+1 }}</td>
                        <td>
                            <div class="flex justify-start space-x-1">
                                <edit-button
                                    @click="model = record"
                                />
                                <delete-button
                                    @click="deleteRow(record)"
                                />
                            </div>
                        </td>
                        <td>{{ record.country_name }}</td>
                        <td>{{ record.bank_name }}</td>
                        <td>{{ record.account_name }}</td>
                        <td>{{ record.account_number }}</td>
                        <td>{{ $helper.dateTimeFormat(record.created_at) }}</td>
                    </tr>
                </template>
            </auto-datatable>
        </custom-card>
        <panel-modal
            v-if="model"
            :has-footer="false"
            @close="model = null"
        >
            <template #body>
                <model-form
                    :form-model="model"
                    @update="updateRow"
                />
            </template>
        </panel-modal>
    </div>
</template>
<script setup>
import CustomCard from "~/components/custom-card.vue";
import PanelModal from "~/components/panel-modal.vue";
import AutoDatatable from "~/components/auto-datatable.vue";
import CreateButton from "~/components/button/create-button.vue";
import ModelForm from '~/pages/main/other/company-bank/model-form.vue';
import {inject, ref} from "vue";
import EditButton from "~/components/button/edit-button.vue";
import DeleteButton from "~/components/button/delete-button.vue";
import axios from "axios";

const $helper = inject('$helper');
const model = ref(null);
const dt = ref();
const updateRow = async () => {
    model.value = null;

    await dt.value.loadData();
};

const deleteRow = async (record) => {
    try {
        await $helper.alertConfirm({callback: async (result) => {
                if (result.isConfirmed) {
                    await axios.post('/other/company_bank/delete', {
                        id: record.id
                    });

                    await dt.value.loadData();
                }
            }});

    } catch (e) {
        console.log(e);
    }
}
</script>
